`ziti-sdk-js`
=====================

A JavaScript-based SDK for delivering secure browser-based web applications over a [Ziti Network](https://ziti.dev/about)

<img src="https://ziti.dev/wp-content/uploads/2020/02/ziti.dev_.logo_.png" width="200" />

Learn about Ziti at [ziti.dev](https://ziti.dev)


[![Build](https://github.com/openziti/ziti-sdk-js/workflows/Build/badge.svg?branch=main)]()
[![Issues](https://img.shields.io/github/issues-raw/openziti/ziti-sdk-js)]()
[![Known Vulnerabilities](https://snyk.io/test/npm/@openziti/ziti-sdk-js/badge.svg)](https://snyk.io/test/npm/@openziti/ziti-sdk-js)
[![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](https://opensource.org/licenses/Apache-2.0)
[![npm version][npm-image]][npm-url]
[![](https://data.jsdelivr.com/v1/package/npm/@openziti/ziti-sdk-js/badge?style=rounded)](https://www.jsdelivr.com/package/npm/@openziti/ziti-sdk-js)
[![LOC](https://img.shields.io/tokei/lines/github/openziti/ziti-sdk-js)]()
[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=rounded)](CONTRIBUTING.md)
[![Contributor Covenant](https://img.shields.io/badge/Contributor%20Covenant-v2.0%20adopted-ff69b4.svg)](CODE_OF_CONDUCT.md)
[![CodeSee](https://codesee-docs.s3.amazonaws.com/badge.svg)](https://app.codesee.io/maps/public/12213800-239c-11ec-8afb-0d2533b87e31)


<!-- TOC -->

- [Motivation](#motivation)
- [Features](#features)
- [Installation&nbsp;via&nbsp;NPM](#installing-via-NPM)
- [Installation&nbsp;via&nbsp;jsDelivr&nbsp;CDN](#Installing-via-jsDelivr-CDN)
- [Installation&nbsp;via&nbsp;unpkg&nbsp;CDN](#Installing-via-unpkg-CDN)
- [Configuration](#configuration)
- [License](#license)

<!-- /TOC -->


## Motivation

tbd

## Features

tbd


## Installing via NPM

If you want to embed `ziti-sdk-js` in your build, it is available through [npm](https://www.npmjs.com/package/@openziti/ziti-sdk-js). Simply run the following command:

    npm i @openziti/ziti-sdk-js

You can then use `ziti-sdk-js` as a regular module:

```js
const ziti = require('@openziti/ziti-sdk-js');
```

### Installing via jsDelivr CDN

If you want to use `ziti-sdk-js` directly from the [jsDelivr CDN](https://www.jsdelivr.com/package/npm/@openziti/ziti-sdk-js), simply include this in your html:

For `latest` version:
```html
<script src="https://cdn.jsdelivr.net/npm/@openziti/ziti-sdk-js@latest/dist/ziti.min.js"></script>
```
For specific version (e.g. `0.4.8`):
```html
<script src="https://cdn.jsdelivr.net/npm/@openziti/ziti-sdk-js@0.4.8/dist/ziti.min.js"></script>
```

The above bundles will synchronously create a global `ziti` object that you can call.


### Installing via unpkg CDN

If you want to use `ziti-sdk-js` directly from the [unpkg CDN](https://unpkg.com/#/), simply include this in your html:

For `latest` version:
```html
<script src="https://unpkg.com/@openziti/ziti-sdk-js@latest/dist/ziti.min.js"></script>
```

For specific version (e.g. `0.4.8`):
```html
<script src="https://unpkg.com/@openziti/ziti-sdk-js@0.4.8/dist/ziti.min.js"></script>
```
The above bundles will synchronously create a global `ziti` object that you can call.


## Configuration

tbd

## License

Apache 2.0



[npm-image]: https://flat.badgen.net/npm/v/@openziti/ziti-sdk-js
[npm-url]: https://www.npmjs.com/package/@openziti/ziti-sdk-js
[install-size-image]: https://flat.badgen.net/packagephobia/install/@openziti/ziti-sdk-js
[install-size-url]: https://packagephobia.now.sh/result?p=@openziti/ziti-sdk-js
