"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/**
 * Module dependencies.
 */
var flatOptions = require('flat-options');

var defaultOptions = require('./connection-options');

var edge_protocol = require('./protocol');

var Messages = require('./messages');
/**
 * @typicalname connection
 */


module.exports = /*#__PURE__*/function () {
  /**
   *
   * @param {Options} [options]
   */
  function ZitiConnection(options) {
    _classCallCheck(this, ZitiConnection);

    this._options = flatOptions(options, defaultOptions);
    this._ctx = this._options.ctx;
    this._data = this._options.data;
    this._state = edge_protocol.conn_state.Initial;
    this._timeout = this._ctx.getTimeout();
    this._edgeMsgSeq = 1;
    this._id = this._ctx.getNextConnectionId();
    this._messages = new Messages({
      ctx: this._ctx,
      conn: this
    });
  }

  _createClass(ZitiConnection, [{
    key: "getCtx",
    value: function getCtx() {
      return this._ctx;
    }
  }, {
    key: "getData",
    value: function getData() {
      return this._data;
    }
  }, {
    key: "getMessages",
    value: function getMessages() {
      return this._messages;
    }
  }, {
    key: "getState",
    value: function getState() {
      return this._state;
    }
  }, {
    key: "setState",
    value: function setState(state) {
      this._state = state;
    }
  }, {
    key: "getId",
    value: function getId() {
      return this._id;
    }
  }, {
    key: "getAndIncrementSequence",
    value: function getAndIncrementSequence() {
      var seq = this._edgeMsgSeq;
      this._edgeMsgSeq++;
      return seq;
    }
  }, {
    key: "getSocket",
    value: function getSocket() {
      return this._socket;
    }
  }, {
    key: "setSocket",
    value: function setSocket(socket) {
      this._socket = socket;
    }
  }, {
    key: "getDataCallback",
    value: function getDataCallback() {
      return this._dataCallback;
    }
  }, {
    key: "setDataCallback",
    value: function setDataCallback(fn) {
      this._dataCallback = fn;
    }
  }, {
    key: "getChannel",
    value: function getChannel() {
      return this._channel;
    }
  }, {
    key: "setChannel",
    value: function setChannel(channel) {
      this._channel = channel;
    }
  }, {
    key: "getEncrypted",
    value: function getEncrypted() {
      return this._encrypted;
    }
  }, {
    key: "setEncrypted",
    value: function setEncrypted(encrypted) {
      this._encrypted = encrypted;
    }
  }, {
    key: "getCryptoEstablishComplete",
    value: function getCryptoEstablishComplete() {
      return this._cryptoEstablishComplete;
    }
  }, {
    key: "setCryptoEstablishComplete",
    value: function setCryptoEstablishComplete(complete) {
      this._cryptoEstablishComplete = complete;
    }
  }, {
    key: "getKeypair",
    value: function getKeypair() {
      return this._keypair;
    }
  }, {
    key: "setKeypair",
    value: function setKeypair(keypair) {
      this._keypair = keypair;
    }
  }, {
    key: "getSharedRx",
    value: function getSharedRx() {
      return this._sharedRx;
    }
  }, {
    key: "setSharedRx",
    value: function setSharedRx(sharedRx) {
      this._sharedRx = sharedRx;
    }
  }, {
    key: "getSharedTx",
    value: function getSharedTx() {
      return this._sharedTx;
    }
  }, {
    key: "setSharedTx",
    value: function setSharedTx(sharedTx) {
      this._sharedTx = sharedTx;
    }
  }, {
    key: "getCrypt_o",
    value: function getCrypt_o() {
      return this._crypt_o;
    }
  }, {
    key: "setCrypt_o",
    value: function setCrypt_o(crypt_o) {
      this._crypt_o = crypt_o;
    }
  }, {
    key: "getCrypt_i",
    value: function getCrypt_i() {
      return this._crypt_i;
    }
  }, {
    key: "setCrypt_i",
    value: function setCrypt_i(crypt_i) {
      this._crypt_i = crypt_i;
    }
  }]);

  return ZitiConnection;
}();