"use strict";

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.map.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/**
 * Class to manage connections.
 * @private
 */
module.exports = /*#__PURE__*/function () {
  function ZitiConnections() {
    _classCallCheck(this, ZitiConnections);

    this._items = new Map();
  }

  _createClass(ZitiConnections, [{
    key: "_saveConnection",
    value: function _saveConnection(conn) {
      this._items.set(conn.getId(), conn);
    }
  }, {
    key: "_deleteConnection",
    value: function _deleteConnection(conn) {
      this._items.delete(conn.getId());
    }
  }, {
    key: "_getConnection",
    value: function _getConnection(connId) {
      if (this._items.has(connId)) {
        return this._items.get(connId);
      } else {
        return undefined;
      }
    }
  }]);

  return ZitiConnections;
}();