"use strict";

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

require("core-js/modules/web.timers.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

require("core-js/modules/es.string.split.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.array-buffer.slice.js");

require("core-js/modules/es.typed-array.uint8-array.js");

require("core-js/modules/es.typed-array.copy-within.js");

require("core-js/modules/es.typed-array.every.js");

require("core-js/modules/es.typed-array.fill.js");

require("core-js/modules/es.typed-array.filter.js");

require("core-js/modules/es.typed-array.find.js");

require("core-js/modules/es.typed-array.find-index.js");

require("core-js/modules/es.typed-array.for-each.js");

require("core-js/modules/es.typed-array.includes.js");

require("core-js/modules/es.typed-array.index-of.js");

require("core-js/modules/es.typed-array.iterator.js");

require("core-js/modules/es.typed-array.join.js");

require("core-js/modules/es.typed-array.last-index-of.js");

require("core-js/modules/es.typed-array.map.js");

require("core-js/modules/es.typed-array.reduce.js");

require("core-js/modules/es.typed-array.reduce-right.js");

require("core-js/modules/es.typed-array.reverse.js");

require("core-js/modules/es.typed-array.set.js");

require("core-js/modules/es.typed-array.slice.js");

require("core-js/modules/es.typed-array.some.js");

require("core-js/modules/es.typed-array.sort.js");

require("core-js/modules/es.typed-array.subarray.js");

require("core-js/modules/es.typed-array.to-locale-string.js");

require("core-js/modules/es.typed-array.to-string.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("regenerator-runtime/runtime.js");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/**
 * Module dependencies.
 */
var flatOptions = require('flat-options'); // const MicroModal            = require('micromodal');


var isEqual = require('lodash.isequal');

var isUndefined = require('lodash.isundefined');

var forEach = require('lodash.foreach');

var formatMessage = require('format-message');

var jwt_decode = require('jwt-decode');

var forge = require('node-forge');

var pkijs = require("pkijs");

var asn1js = require('asn1js');

var isNull = require('lodash.isnull');

var asn1 = forge.asn1;

var ls = require('../utils/localstorage');

var defaultOptions = require('./options');

var ZitiUPDB = require('../updb/updb');

var error = require('../updb/error'); // const identityModalCSS      = require('../ui/identity_modal/css');
// const identityModalHTML     = require('../ui/identity_modal/html');
// const identityModalSelect   = require('../ui/identity_modal/select');
// const identityModalDragDrop = require('../ui/identity_modal/dragdrop');
// const identityModalLogin    = require('../ui/identity_modal/login');
// const error                 = require('../ui/identity_modal/error');


var zitiConstants = require('../constants');

var ZitiControllerClient = require('../context/controller-client');

var _require = require('../utils/throwif'),
    throwIf = _require.throwIf;

var base64_url_decode = require('./base64_url_decode');

var pkiUtil = require('../utils/pki');

var Base64 = require('./base64');

var pjson = require('../../package.json');
/**
 * Expose `ZitiEnroller`.
 */


module.exports = ZitiEnroller;
/**
 * Initialize a new `ZitiEnroller`.
 *
 * @api public
 */

function ZitiEnroller(obj) {
  var ctx = mixin(obj);
  return ctx;
}
/**
 * Mixin the prototype properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */


function mixin(obj) {
  for (var key in ZitiEnroller.prototype) {
    if (Object.prototype.hasOwnProperty.call(ZitiEnroller.prototype, key)) obj[key] = ZitiEnroller.prototype[key];
  }

  return obj;
}
/**
 * Initialize the Ziti Enroller.
 * 
 * @param {Object} [options]
 * @returns {nothing}   
 */


ZitiEnroller.prototype.init = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options) {
    var _options;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _options = flatOptions(options, defaultOptions);
            this.ctx = _options.ctx;
            this.logger = _options.logger;

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();
/**
 * Injects and opens the Modal dialog that prompts for the JWT file.
 *
 */


ZitiEnroller.prototype.loadJWTFromFileSystem = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
  var self;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          self = this;

          if (!this._modalIsOpen) {
            _context2.next = 3;
            break;
          }

          return _context2.abrupt("return");

        case 3:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2, this);
}));
/**
 * Return a Promise that will resolve as soon as we have acquired login creds from the UI.
 *
 * @returns {Promise}   
 */

ZitiEnroller.prototype._awaitLoginFormComplete = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
  var self;
  return regeneratorRuntime.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          this.logger.debug('enroll._awaitLoginFormComplete() starting');
          self = this;
          this.loadJWTFromFileSystem();
          return _context3.abrupt("return", new Promise(function (resolve, reject) {
            //TEMP
            // self._loginFormValues = { username: 'admin', password: 'admin' };    
            //TEMP
            (function waitForJWTLoadFromFileSystemComplete() {
              if (self._loginFormValues) {
                return resolve(self._loginFormValues);
              }

              self.logger.debug('_awaitLoginFormComplete() _loginFormValues still not present');
              setTimeout(waitForJWTLoadFromFileSystemComplete, 500);
            })();
          }));

        case 4:
        case "end":
          return _context3.stop();
      }
    }
  }, _callee3, this);
}));
/**
 * Return a Promise that will resolve as soon as we have gotten login creds from the UI and those creds 
 * have been used to successfully acquire an API session.
 *
 * @returns {Promise}   
 */

ZitiEnroller.prototype._awaitHaveAPISession = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
  var self;
  return regeneratorRuntime.wrap(function _callee6$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          self = this;
          return _context6.abrupt("return", new Promise( /*#__PURE__*/function () {
            var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(resolve, reject) {
              var apisess, updb;
              return regeneratorRuntime.wrap(function _callee5$(_context5) {
                while (1) {
                  switch (_context5.prev = _context5.next) {
                    case 0:
                      self.logger.debug('enroll._awaitHaveAPISession() starting'); //

                      _context5.next = 3;
                      return ls.getWithExpiry(zitiConstants.get().ZITI_API_SESSION_TOKEN);

                    case 3:
                      apisess = _context5.sent;

                      if (!isNull(apisess)) {
                        self.ctx._apiSession = apisess;
                      }

                      updb = new ZitiUPDB(ZitiUPDB.prototype);
                      _context5.next = 8;
                      return updb.init({
                        ctx: ziti._ctx,
                        logger: ziti._ctx.logger
                      });

                    case 8:
                      if (!isUndefined(self.ctx._apiSession)) {
                        _context5.next = 17;
                        break;
                      }

                      _context5.next = 11;
                      return updb.awaitLoginFormComplete();

                    case 11:
                      self._loginFormValues = _context5.sent;
                      // await user creds input
                      self.logger.debug('login Form submitted: creds are [%o]', self._loginFormValues); // Establish an API session with Controller

                      _context5.next = 15;
                      return self.getAPISession(self).catch( /*#__PURE__*/function () {
                        var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(err) {
                          return regeneratorRuntime.wrap(function _callee4$(_context4) {
                            while (1) {
                              switch (_context4.prev = _context4.next) {
                                case 0:
                                  error.setMessage('ERROR: Invalid credentials');
                                  self._loginFormValues = undefined;
                                  _context4.next = 4;
                                  return ls.removeItem(zitiConstants.get().ZITI_IDENTITY_USERNAME);

                                case 4:
                                  _context4.next = 6;
                                  return ls.removeItem(zitiConstants.get().ZITI_IDENTITY_PASSWORD);

                                case 6:
                                  reject(err);

                                case 7:
                                case "end":
                                  return _context4.stop();
                              }
                            }
                          }, _callee4);
                        }));

                        return function (_x4) {
                          return _ref6.apply(this, arguments);
                        };
                      }());

                    case 15:
                      _context5.next = 8;
                      break;

                    case 17:
                      self.logger.debug('API session acquired: token is [%o]', self.ctx._apiSession.token);
                      resolve();

                    case 19:
                    case "end":
                      return _context5.stop();
                  }
                }
              }, _callee5);
            }));

            return function (_x2, _x3) {
              return _ref5.apply(this, arguments);
            };
          }()));

        case 2:
        case "end":
          return _context6.stop();
      }
    }
  }, _callee6, this);
}));
/**
 * 
 *
 */

ZitiEnroller.prototype.enroll = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
  var _this = this;

  var self;
  return regeneratorRuntime.wrap(function _callee8$(_context8) {
    while (1) {
      switch (_context8.prev = _context8.next) {
        case 0:
          self = this;
          return _context8.abrupt("return", new Promise( /*#__PURE__*/function () {
            var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(resolve, reject) {
              var publicKey, privateKey;
              return regeneratorRuntime.wrap(function _callee7$(_context7) {
                while (1) {
                  switch (_context7.prev = _context7.next) {
                    case 0:
                      self.logger.debug('enroll() starting');
                      _context7.next = 3;
                      return ls.getWithExpiry(zitiConstants.get().ZITI_IDENTITY_PUBLIC_KEY);

                    case 3:
                      publicKey = _context7.sent;
                      _context7.next = 6;
                      return ls.getWithExpiry(zitiConstants.get().ZITI_IDENTITY_PRIVATE_KEY);

                    case 6:
                      privateKey = _context7.sent;

                      if (!(isNull(publicKey) || isUndefined(publicKey) || isNull(privateKey) || isUndefined(privateKey))) {
                        _context7.next = 9;
                        break;
                      }

                      return _context7.abrupt("return", reject('no keypair found!'));

                    case 9:
                      _context7.next = 11;
                      return ziti._ctx.ensureAPISession();

                    case 11:
                      _this._publicKey = forge.pki.publicKeyFromPem(publicKey);
                      _this._privateKey = forge.pki.privateKeyFromPem(privateKey);

                      _this.generateCSR();

                      _context7.next = 16;
                      return _this.createEphemeralCert();

                    case 16:
                      resolve();

                    case 17:
                    case "end":
                      return _context7.stop();
                  }
                }
              }, _callee7);
            }));

            return function (_x5, _x6) {
              return _ref8.apply(this, arguments);
            };
          }()));

        case 2:
        case "end":
          return _context8.stop();
      }
    }
  }, _callee8, this);
})); // ZitiEnroller.prototype._dismissModal = function() {
// MicroModal.close('ziti-updb-modal');
// this._modalIsOpen = false;
// }

/**
 * 
 *
 */

ZitiEnroller.prototype.getAPISession = /*#__PURE__*/function () {
  var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(who) {
    var self;
    return regeneratorRuntime.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            // error.setProgress('Transmitting Authenticate Request');
            self = who;
            return _context10.abrupt("return", new Promise( /*#__PURE__*/function () {
              var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(resolve, reject) {
                var res;
                return regeneratorRuntime.wrap(function _callee9$(_context9) {
                  while (1) {
                    switch (_context9.prev = _context9.next) {
                      case 0:
                        _context9.next = 2;
                        return self.ctx._controllerClient.authenticate({
                          method: 'password',
                          body: {
                            username: self._loginFormValues.username,
                            password: self._loginFormValues.password,
                            configTypes: ['ziti-tunneler-client.v1'],
                            envInfo: {
                              arch: window.navigator.platform,
                              // e.g. 'MacIntel'
                              os: window.navigator.appVersion // e.g. '5.0 (Macintosh; Intel Mac OS X 10_15_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4280.88 Safari/537.36'

                            },
                            sdkInfo: {
                              // branch: "string",
                              // revision: "string",
                              type: 'ziti-sdk-js',
                              version: pjson.version
                            }
                          }
                        });

                      case 2:
                        res = _context9.sent;

                        if (isUndefined(res.error)) {
                          _context9.next = 7;
                          break;
                        }

                        self.logger.error(res.error.message); // error.setMessage('ERROR: ' + res.error.message);
                        // error.setProgress('');

                        // error.setMessage('ERROR: ' + res.error.message);
                        // error.setProgress('');
                        reject(res.error.message);
                        return _context9.abrupt("return");

                      case 7:
                        self.ctx._apiSession = res.data;
                        self.logger.debug('Controller API Session established: [%o]', self.ctx._apiSession); // Set the token header on behalf of all subsequent Controller API calls

                        // Set the token header on behalf of all subsequent Controller API calls
                        self.ctx._controllerClient.setApiKey(self.ctx._apiSession.token, 'zt-session', false); //


                        _context9.next = 12;
                        return ls.setWithExpiry(zitiConstants.get().ZITI_API_SESSION_TOKEN, self.ctx._apiSession, new Date(8640000000000000));

                      case 12:
                        resolve();

                      case 13:
                      case "end":
                        return _context9.stop();
                    }
                  }
                }, _callee9);
              }));

              return function (_x8, _x9) {
                return _ref10.apply(this, arguments);
              };
            }()));

          case 2:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10);
  }));

  return function (_x7) {
    return _ref9.apply(this, arguments);
  };
}();
/**
 * 
 */


ZitiEnroller.prototype.createEphemeralCert = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
  var _this2 = this;

  var self;
  return regeneratorRuntime.wrap(function _callee12$(_context12) {
    while (1) {
      switch (_context12.prev = _context12.next) {
        case 0:
          self = this;
          return _context12.abrupt("return", new Promise( /*#__PURE__*/function () {
            var _ref12 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(resolve, reject) {
              var certPEM, flatcert, certificate, expiryTime, expiryDate, becomesUsableTime, becomesUsableTimeString, now, nowTime;
              return regeneratorRuntime.wrap(function _callee11$(_context11) {
                while (1) {
                  switch (_context11.prev = _context11.next) {
                    case 0:
                      _context11.next = 2;
                      return self.ctx._controllerClient.createCurrentApiSessionCertificate({
                        body: {
                          csr: _this2._csr
                        }
                      });

                    case 2:
                      res = _context11.sent;

                      if (isUndefined(res.error)) {
                        _context11.next = 7;
                        break;
                      }

                      _this2.logger.error(res.error.message); // error.setMessage('ERROR: Ephemeral Cert creation failed - ' + res.error.message);


                      // error.setMessage('ERROR: Ephemeral Cert creation failed - ' + res.error.message);
                      reject(res.error.message);
                      return _context11.abrupt("return");

                    case 7:
                      if (!isUndefined(res.data.certificate)) {
                        _context11.next = 11;
                        break;
                      }

                      _this2.logger.error('cert not returned in response from detailCurrentApiSessionCertificate'); // error.setMessage('ERROR: Ephemeral Cert creation failed');


                      // error.setMessage('ERROR: Ephemeral Cert creation failed');
                      reject('Ephemeral Cert creation failed');
                      return _context11.abrupt("return");

                    case 11:
                      certPEM = res.data.certificate;
                      certPEM = certPEM.replace(/\\n/g, '\n');
                      certPEM = certPEM.replace(/[\r]+/g, '');
                      certPEM = certPEM.replace(/\n/g, '\x0a');
                      flatcert = certPEM.replace(/\\n/g, '\n');

                      try {
                        certificate = pkiUtil.convertPemToCertificate(flatcert);
                        pkiUtil.printCertificate(certificate);
                      } catch (err) {
                        self.logger.error('controllerClient.createCurrentApiSessionCertificate returned cert [%o] which pkiUtil.convertPemToCertificate cannot process', certPEM);
                        reject('controllerClient.createCurrentApiSessionCertificate returned cert which pkiUtil.convertPemToCertificate cannot process');
                      }

                      expiryTime = pkiUtil.getExpiryTimeFromCertificate(certificate);
                      expiryDate = new Date(expiryTime); //

                      //
                      becomesUsableTime = pkiUtil.getBecomesUsableTimeFromCertificate(certificate);
                      becomesUsableTimeString = pkiUtil.getBecomesUsableStringFromCertificate(certificate);
                      now = new Date();
                      nowTime = now.getTime();
                      self.logger.info('controllerClient.createCurrentApiSessionCertificate returned cert with NotBefore time [%o][%o], it is now [%o][%o], difference of [%o]', becomesUsableTime, becomesUsableTimeString, nowTime, now, nowTime - becomesUsableTime);

                      if (nowTime < becomesUsableTime) {
                        self.logger.error('controllerClient.createCurrentApiSessionCertificate returned cert with NotBefore IN THE FUTURE', becomesUsableTimeString);
                      } //


                      //
                      self.logger.debug('controllerClient.createCurrentApiSessionCertificate returned cert with expiryTime: [%o] expiryDate:[%o]', expiryTime, expiryDate);
                      _context11.next = 28;
                      return ls.setWithExpiry(zitiConstants.get().ZITI_IDENTITY_CERT, certPEM, expiryTime);

                    case 28:
                      resolve();

                    case 29:
                    case "end":
                      return _context11.stop();
                  }
                }
              }, _callee11);
            }));

            return function (_x10, _x11) {
              return _ref12.apply(this, arguments);
            };
          }()));

        case 2:
        case "end":
          return _context12.stop();
      }
    }
  }, _callee12, this);
}));
/**
 * 
 *
 */

ZitiEnroller.prototype.enrollOTF = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14() {
  var _this3 = this;

  var self;
  return regeneratorRuntime.wrap(function _callee14$(_context14) {
    while (1) {
      switch (_context14.prev = _context14.next) {
        case 0:
          // error.setProgress('Transmitting Enroll Request');
          self = this;
          return _context14.abrupt("return", new Promise( /*#__PURE__*/function () {
            var _ref14 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(resolve, reject) {
              var certPEM, flatcert, certificate, expiryTime;
              return regeneratorRuntime.wrap(function _callee13$(_context13) {
                while (1) {
                  switch (_context13.prev = _context13.next) {
                    case 0:
                      _context13.next = 2;
                      return self.ctx._controllerClient.enrollOtf({
                        method: 'otf',
                        username: self._loginFormValues.username,
                        // token: this._decoded_jwt.jti,
                        body: _this3._csr
                      });

                    case 2:
                      res = _context13.sent;

                      if (isUndefined(res.error)) {
                        _context13.next = 7;
                        break;
                      }

                      _this3.logger.error(res.error.message); // error.setMessage('ERROR: Enrollment failed - ' + res.error.message);


                      // error.setMessage('ERROR: Enrollment failed - ' + res.error.message);
                      reject(res.error.message);
                      return _context13.abrupt("return");

                    case 7:
                      // error.setProgress('OTF Enrollment SUCCEEDED - This dialog will auto-dismiss in a few seconds');
                      certPEM = res.data.cert;
                      flatcert = certPEM.replace(/\\n/g, '\n');

                      try {
                        certificate = pkiUtil.convertPemToCertificate(flatcert);
                      } catch (err) {
                        self.logger.error('controllerClient.enroll returned cert [%o] which pkiUtil.convertPemToCertificate cannot process', certPEM);
                        reject('controllerClient.enroll returned cert which pkiUtil.convertPemToCertificate cannot process');
                      }

                      expiryTime = pkiUtil.getExpiryTimeFromCertificate(certificate);
                      _context13.next = 13;
                      return ls.setWithExpiry(zitiConstants.get().ZITI_EXPIRY_TIME, expiryTime, expiryTime);

                    case 13:
                      self.logger.trace('controllerClient.enroll returned cert: [%o] with expiryTime: [%o]', certPEM, expiryTime); // let pk = forge.pki.privateKeyToPem(self._privateKey);
                      // pk = pk.replaceAll(/\\n/g, '\n');
                      // pk = pk.replaceAll('\r', '');
                      // await ls.setWithExpiry(zitiConstants.get().ZITI_IDENTITY_PRIVATE_KEY, pk, expiryTime);

                      _context13.next = 16;
                      return ls.setWithExpiry(zitiConstants.get().ZITI_IDENTITY_CERT, certPEM, expiryTime);

                    case 16:
                      _context13.next = 18;
                      return ls.setWithExpiry(zitiConstants.get().ZITI_CONTROLLER, window.zitiConfig.controller.api, expiryTime);

                    case 18:
                      _context13.next = 20;
                      return self.ctx._controllerClient.listProtocols();

                    case 20:
                      res = _context13.sent;
                      self.logger.trace('controllerClient.listProtocols returned: [%o]', res);

                      if (isUndefined(res.data.ws)) {
                        reject('controllerClient.listProtocols data contains no "ws" section');
                      }

                      if (isUndefined(res.data.ws.address)) {
                        reject('controllerClient.listProtocols "ws" section contains no "address');
                      }

                      _context13.next = 26;
                      return ls.setWithExpiry(zitiConstants.get().ZITI_CONTROLLER_WS, 'ws://' + res.data.ws.address, expiryTime);

                    case 26:
                      resolve();

                    case 27:
                    case "end":
                      return _context13.stop();
                  }
                }
              }, _callee13);
            }));

            return function (_x12, _x13) {
              return _ref14.apply(this, arguments);
            };
          }()));

        case 2:
        case "end":
          return _context14.stop();
      }
    }
  }, _callee14, this);
}));
/**
 * 
 *
 */

/*
ZitiEnroller.prototype.enrollOTT = async function() {

  // error.setProgress('Transmitting Enroll Request');

  let self = this;

  return new Promise( async (resolve, reject) => {

    let controllerClient = new ZitiControllerClient({
      domain: self._decoded_jwt.iss,
      logger: self.logger
    });

    let certPEM;

    // Enroll the Identity
    let response = await controllerClient.enroll({
      method: 'ott',
      token: this._decoded_jwt.jti,
      body:  this._csr
    });

    if (!response.ok) {
      let json = await response.json();
      // error.setMessage('ERROR: Enrollment failed - ' + json.error.message);
      // error.setProgress();
      reject(json);
      return;
    } else {
      // error.setProgress('Enrollment SUCCEEDED - This dialog will auto-dismiss in a few seconds');
      let blob = await response.blob();
      certPEM = await blob.text();
    }  

    let flatcert = certPEM.replace(/\\n/g, '\n');

    let certificate;
    try {
      certificate = pkiUtil.convertPemToCertificate( flatcert );
    } catch (err) {
      self.logger.error('controllerClient.enroll returned cert [%o] which pkiUtil.convertPemToCertificate cannot process', certPEM);
      reject('controllerClient.enroll returned cert which pkiUtil.convertPemToCertificate cannot process');
    }

    let expiryTime = pkiUtil.getExpiryTimeFromCertificate(certificate);

    self.logger.trace('controllerClient.enroll returned cert: [%o] with expiryTime: [%o]', certPEM, expiryTime);

    let pk = forge.pki.privateKeyToPem(self._privateKey);
    pk = pk.replaceAll(/\\n/g, '\n');
    pk = pk.replaceAll('\r', '');
    ls.setWithExpiry(zitiConstants.get().ZITI_IDENTITY_PRIVATE_KEY, pk, expiryTime);

    ls.setWithExpiry(zitiConstants.get().ZITI_IDENTITY_CERT, certPEM, expiryTime);

    let flatca = self._certChain.replaceAll(/\\n/g, '\n');
    flatca = flatca.replaceAll('\r', '');
    ls.setWithExpiry(zitiConstants.get().ZITI_IDENTITY_CA, flatca, expiryTime);

    ls.setWithExpiry(zitiConstants.get().ZITI_CONTROLLER, self._decoded_jwt.iss, expiryTime);

    // Get Controller protocols info
    let res = await controllerClient.listProtocols();
    self.logger.trace('controllerClient.listProtocols returned: [%o]', res);
    if (isUndefined(res.data.ws)) {
      reject('controllerClient.listProtocols data contains no "ws" section');
    }
    if (isUndefined(res.data.ws.address)) {
      reject('controllerClient.listProtocols "ws" section contains no "address');
    }
    ls.setWithExpiry(zitiConstants.get().ZITI_CONTROLLER_WS, 'ws://' + res.data.ws.address , expiryTime);

    resolve()

  });
}
*/

/**
 * Loads the JWT from local storage.
 *
 */

ZitiEnroller.prototype.loadJWTFromLocalStorage = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15() {
  return regeneratorRuntime.wrap(function _callee15$(_context15) {
    while (1) {
      switch (_context15.prev = _context15.next) {
        case 0:
          _context15.next = 2;
          return ls.getWithExpiry(zitiConstants.get().ZITI_JWT);

        case 2:
          this._rawJWT = _context15.sent;
          this._decoded_jwt = jwt_decode(this._rawJWT);
          this.logger.debug('decoded JWT: %o', this._decoded_jwt);
          this._jwt_sig = this._rawJWT.split(".")[2];
          this.logger.debug('JWT Signature: %o', this._jwt_sig);
          this._jwt_sig_decoded = base64_url_decode(this._jwt_sig);
          this.logger.debug('JWT Signature (decoded): %o', this._jwt_sig_decoded);

        case 9:
        case "end":
          return _context15.stop();
      }
    }
  }, _callee15, this);
}));
/**
 * 
 *
 */

ZitiEnroller.prototype.getWellKnownCerts = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17() {
  var self;
  return regeneratorRuntime.wrap(function _callee17$(_context17) {
    while (1) {
      switch (_context17.prev = _context17.next) {
        case 0:
          // error.setProgress('starting fetch of Controller well-known certs');
          self = this;
          return _context17.abrupt("return", new Promise( /*#__PURE__*/function () {
            var _ref17 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16(resolve, reject) {
              var controllerClient;
              return regeneratorRuntime.wrap(function _callee16$(_context16) {
                while (1) {
                  switch (_context16.prev = _context16.next) {
                    case 0:
                      controllerClient = new ZitiControllerClient({
                        domain: window.zitiConfig.controller.api,
                        // set in HTML of web app that embeds ziti-sdk-js
                        logger: self.logger
                      }); // Get Controller's well-known certs

                      _context16.next = 3;
                      return controllerClient.listWellKnownCas();

                    case 3:
                      self._wellKnownCerts = _context16.sent;
                      self.logger.trace('Controller well-known certs: [%o]', self._wellKnownCerts); // error.setProgress('Controller well-known certs obtained');

                      // error.setProgress('Controller well-known certs obtained');
                      resolve();

                    case 6:
                    case "end":
                      return _context16.stop();
                  }
                }
              }, _callee16);
            }));

            return function (_x14, _x15) {
              return _ref17.apply(this, arguments);
            };
          }()));

        case 2:
        case "end":
          return _context17.stop();
      }
    }
  }, _callee17, this);
}));
/**
 * 
 *
 */

ZitiEnroller.prototype.parsePKCS7 = function () {
  var self = this;
  this._base64DecodedPkcs7 = Base64.decode(this._wellKnownCerts);
  this.logger.trace('base64_decoded_pkcs7: [%o]', this._base64DecodedPkcs7);
  var decoded_asn1 = asn1js.fromBER(this._base64DecodedPkcs7.buffer);
  this.logger.trace('asn1: [%o]', asn1);
  var decoded_sequence = decoded_asn1.result;
  var valueArray = decoded_sequence.valueBlock.value;
  throwIf(!isEqual(valueArray.length, 2), formatMessage('Should be 2 elements', {}));
  var pkcs7_signedData_OID = valueArray[0];
  this.logger.trace('pkcs7_signedData_OID: [%o]', pkcs7_signedData_OID);
  var OID_PKCS7_SIGNED_DATA = new Uint8Array([6, 9, 42, 134, 72, 134, 247, 13, 1, 7, 2]);
  throwIf(!isEqual(OID_PKCS7_SIGNED_DATA.buffer, pkcs7_signedData_OID.valueBeforeDecode), formatMessage('invalid pkcs7 signed data', {}));
  valueArray = valueArray[1].valueBlock.value;
  throwIf(!isEqual(valueArray.length, 1), formatMessage('Should be 1 elements', {}));
  valueArray = valueArray[0].valueBlock.value;
  throwIf(!isEqual(valueArray.length, 6), formatMessage('Should be 6 elements', {}));
  var pkcs7_Data_OID = valueArray[2].valueBlock.value[0];
  this.logger.trace('pkcs7_Data_OID: [%o]', pkcs7_Data_OID);
  var OID_PKCS7_DATA = new Uint8Array([6, 9, 42, 134, 72, 134, 247, 13, 1, 7, 1]);
  throwIf(!isEqual(OID_PKCS7_DATA.buffer, pkcs7_Data_OID.valueBeforeDecode), formatMessage('invalid pkcs7 data', {}));
  var cmsContentSimpl = new pkijs.ContentInfo({
    schema: decoded_asn1.result
  });
  var cmsSignedSimpl = new pkijs.SignedData({
    schema: cmsContentSimpl.content
  });
  var certArray = cmsSignedSimpl.certificates;
  this.logger.trace('certArray: [%o]', certArray);
  this._certChain = "";
  forEach(certArray, function (cert) {
    self._certChain += self.convertBinaryToPem(cert.toSchema(true).toBER(false), "CERTIFICATE");
  });
  this.logger.trace('certChain: [%o]', this._certChain);
};

ZitiEnroller.prototype.generateKeyPair = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee20() {
  var privateKeySize, tick, self;
  return regeneratorRuntime.wrap(function _callee20$(_context20) {
    while (1) {
      switch (_context20.prev = _context20.next) {
        case 0:
          privateKeySize = 4096;
          tick = 1; // error.setProgress('Starting KeyPair Generation');

          console.log('Starting KeyPair Generation');
          self = this;
          return _context20.abrupt("return", new Promise( /*#__PURE__*/function () {
            var _ref19 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee19(resolve, reject) {
              var state, step;
              return regeneratorRuntime.wrap(function _callee19$(_context19) {
                while (1) {
                  switch (_context19.prev = _context19.next) {
                    case 0:
                      // Generate an RSA key pair in steps.
                      // We run for a few ms at a time on the main JS thread, so as not to completely block JS execution in browser.
                      state = forge.pki.rsa.createKeyPairGenerationState(privateKeySize);

                      step = /*#__PURE__*/function () {
                        var _ref20 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18() {
                          var privatePEM, publicPEM;
                          return regeneratorRuntime.wrap(function _callee18$(_context18) {
                            while (1) {
                              switch (_context18.prev = _context18.next) {
                                case 0:
                                  if (forge.pki.rsa.stepKeyPairGenerationState(state, 100)) {
                                    _context18.next = 6;
                                    break;
                                  }

                                  // self.logger.trace('keypair generation tick... [%o]', state);
                                  console.log('keypair generation tick... ', state);

                                  if (tick++ % 20 == 0) {// error.setProgress('Generating keypair for your Identity, please stand by... progress[' + tick + ']');
                                  }

                                  setTimeout(step, 1);
                                  _context18.next = 20;
                                  break;

                                case 6:
                                  self._privateKey = state.keys.privateKey;
                                  self._publicKey = state.keys.publicKey;
                                  privatePEM = forge.pki.privateKeyToPem(self._privateKey);
                                  privatePEM = privatePEM.replace(/\\n/g, '\n');
                                  privatePEM = privatePEM.replace('\r', '');
                                  _context18.next = 13;
                                  return ls.setWithExpiry(zitiConstants.get().ZITI_IDENTITY_PRIVATE_KEY, privatePEM, new Date(8640000000000000));

                                case 13:
                                  publicPEM = forge.pki.publicKeyToPem(self._publicKey);
                                  publicPEM = publicPEM.replace(/\\n/g, '\n');
                                  publicPEM = publicPEM.replace('\r', '');
                                  _context18.next = 18;
                                  return ls.setWithExpiry(zitiConstants.get().ZITI_IDENTITY_PUBLIC_KEY, publicPEM, new Date(8640000000000000));

                                case 18:
                                  // error.setProgress('KeyPair Generation Complete');
                                  console.log('KeyPair Generation Complete');
                                  resolve(state.keys);

                                case 20:
                                case "end":
                                  return _context18.stop();
                              }
                            }
                          }, _callee18);
                        }));

                        return function step() {
                          return _ref20.apply(this, arguments);
                        };
                      }();

                      setTimeout(step); // initiate async keypair generation

                    case 3:
                    case "end":
                      return _context19.stop();
                  }
                }
              }, _callee19);
            }));

            return function (_x16, _x17) {
              return _ref19.apply(this, arguments);
            };
          }()));

        case 5:
        case "end":
          return _context20.stop();
      }
    }
  }, _callee20, this);
}));

ZitiEnroller.prototype.generateCSR = function (binaryData, label) {
  var csr = forge.pki.createCertificationRequest();
  csr.publicKey = this._publicKey;
  csr.setSubject([{
    name: 'commonName',
    // value: this._decoded_jwt.sub
    value: 'OTF' // }, {
    //   name: 'description',
    //   // value: this._decoded_jwt.iss
    //   value: 'OTF CSR'

  }, {
    name: 'countryName',
    value: 'US'
  }, {
    shortName: 'ST',
    value: 'NC'
  }, {
    name: 'organizationName',
    value: 'OpenZiti'
  }]);
  csr.sign(this._privateKey);
  var verified = csr.verify();
  throwIf(!verified, formatMessage('csr.verify failed', {}));
  this._csr = forge.pki.certificationRequestToPem(csr);
  this.logger.debug('generateCSR results [%o]', this._csr);
};

ZitiEnroller.prototype.convertBinaryToPem = function (binaryData, label) {
  var base64Cert = this.arrayBufferToBase64String(binaryData);
  var pemCert = "-----BEGIN " + label + "-----\r\n";
  var nextIndex = 0;
  var lineLength;

  while (nextIndex < base64Cert.length) {
    if (nextIndex + 64 <= base64Cert.length) {
      pemCert += base64Cert.substr(nextIndex, 64) + "\r\n";
    } else {
      pemCert += base64Cert.substr(nextIndex) + "\r\n";
    }

    nextIndex += 64;
  }

  pemCert += "-----END " + label + "-----\r\n";
  return pemCert;
};

ZitiEnroller.prototype.arrayBufferToBase64String = function (arrayBuffer) {
  var byteArray = new Uint8Array(arrayBuffer);
  var byteString = '';

  for (var i = 0; i < byteArray.byteLength; i++) {
    byteString += String.fromCharCode(byteArray[i]);
  }

  return btoa(byteString);
};