"use strict";

require("core-js/modules/es.array-buffer.constructor.js");

require("core-js/modules/es.array-buffer.slice.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.typed-array.uint8-array.js");

require("core-js/modules/es.typed-array.copy-within.js");

require("core-js/modules/es.typed-array.every.js");

require("core-js/modules/es.typed-array.fill.js");

require("core-js/modules/es.typed-array.filter.js");

require("core-js/modules/es.typed-array.find.js");

require("core-js/modules/es.typed-array.find-index.js");

require("core-js/modules/es.typed-array.for-each.js");

require("core-js/modules/es.typed-array.includes.js");

require("core-js/modules/es.typed-array.index-of.js");

require("core-js/modules/es.typed-array.iterator.js");

require("core-js/modules/es.typed-array.join.js");

require("core-js/modules/es.typed-array.last-index-of.js");

require("core-js/modules/es.typed-array.map.js");

require("core-js/modules/es.typed-array.reduce.js");

require("core-js/modules/es.typed-array.reduce-right.js");

require("core-js/modules/es.typed-array.reverse.js");

require("core-js/modules/es.typed-array.set.js");

require("core-js/modules/es.typed-array.slice.js");

require("core-js/modules/es.typed-array.some.js");

require("core-js/modules/es.typed-array.sort.js");

require("core-js/modules/es.typed-array.subarray.js");

require("core-js/modules/es.typed-array.to-locale-string.js");

require("core-js/modules/es.typed-array.to-string.js");

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.function.name.js");

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var from2 = require('from2');

var toBuffer = require('typedarray-to-buffer');

module.exports = function (file, options) {
  options = options || {};
  var offset = options.offset || 0;
  var chunkSize = options.chunkSize || 1024 * 4;
  var fileReader = new FileReader(file);
  var from = from2(function (size, cb) {
    if (offset >= file.size) return cb(null, null);

    fileReader.onloadend = function loaded(event) {
      var data = event.target.result;
      if (data instanceof ArrayBuffer) data = toBuffer(new Uint8Array(event.target.result));
      cb(null, data);
    };

    var end = offset + chunkSize;
    var slice = file.slice(offset, end);
    fileReader.readAsArrayBuffer(slice);
    offset = end;
  });
  from.name = file.name;
  from.size = file.size;
  from.type = file.type;
  from.lastModified = file.lastModified;

  fileReader.onerror = function (err) {
    from.destroy(err);
  };

  return from;
};