"use strict";

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.object.keys.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.object.set-prototype-of.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.symbol.to-string-tag.js");

require("core-js/modules/es.json.to-string-tag.js");

require("core-js/modules/es.math.to-string-tag.js");

require("core-js/modules/es.array.from.js");

require("core-js/modules/web.dom-collections.for-each.js");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var isUndefined = require('lodash.isundefined');

var invalidTokenRegex = /[^\^_`a-zA-Z\-0-9!#$%&'*+.|~]/;
var invalidHeaderCharRegex = /[^\t\x20-\x7e\x80-\xff]/;

function validateName(name) {
  name = "".concat(name);

  if (invalidTokenRegex.test(name) || name === '') {
    throw new TypeError("".concat(name, " is not a legal HTTP header name"));
  }
}

function validateValue(value) {
  value = "".concat(value);

  if (invalidHeaderCharRegex.test(value)) {
    throw new TypeError("".concat(value, " is not a legal HTTP header value"));
  }
}
/**
 * Find the key in the map object given a header name.
 *
 * Returns undefined if not found.
 *
 * @param   String  name  Header name
 * @return  String|Undefined
 */


function find(map, name) {
  name = name.toLowerCase();

  for (var key in map) {
    if (key.toLowerCase() === name) {
      return key;
    }
  }

  return undefined;
}

var MAP = Symbol('map');

function getHeaders(headers) {
  var kind = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'key+value';
  var keys = Object.keys(headers[MAP]).sort();
  return keys.map(kind === 'key' ? function (k) {
    return k.toLowerCase();
  } : kind === 'value' ? function (k) {
    return headers[MAP][k].join(', ');
  } : function (k) {
    return [k.toLowerCase(), headers[MAP][k].join(', ')];
  });
}

var INTERNAL = Symbol('internal');

function createHeadersIterator(target, kind) {
  var iterator = Object.create(HeadersIteratorPrototype);
  iterator[INTERNAL] = {
    target: target,
    kind: kind,
    index: 0
  };
  return iterator;
}

var HeadersIteratorPrototype = Object.setPrototypeOf({
  next: function next() {
    // istanbul ignore if
    if (!this || Object.getPrototypeOf(this) !== HeadersIteratorPrototype) {
      throw new TypeError('Value of `this` is not a HeadersIterator');
    }

    var _this$INTERNAL = this[INTERNAL],
        target = _this$INTERNAL.target,
        kind = _this$INTERNAL.kind,
        index = _this$INTERNAL.index;
    var values = getHeaders(target, kind);
    var len = values.length;

    if (index >= len) {
      return {
        value: undefined,
        done: true
      };
    }

    this[INTERNAL].index = index + 1;
    return {
      value: values[index],
      done: false
    };
  }
}, Object.getPrototypeOf(Object.getPrototypeOf([][Symbol.iterator]())));
Object.defineProperty(HeadersIteratorPrototype, Symbol.toStringTag, {
  value: 'HeadersIterator',
  writable: false,
  enumerable: false,
  configurable: true
});
/**
 * Expose `HttpHeaders`.
 */

module.exports = HttpHeaders;
/**
 * Initialize a new `HttpHeaders`.
 *
 * @param   Object  headers  Response headers
 * @api public
 */

function HttpHeaders() {
  var init = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
  this[MAP] = Object.create(null);

  if (init instanceof HttpHeaders) {
    var rawHeaders = init.raw();
    var headerNames = Object.keys(rawHeaders);

    for (var _i = 0, _headerNames = headerNames; _i < _headerNames.length; _i++) {
      var headerName = _headerNames[_i];

      var _iterator = _createForOfIteratorHelper(rawHeaders[headerName]),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var value = _step.value;
          this.append(headerName, value);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }

    return;
  } // We don't worry about converting prop to ByteString here as append()
  // will handle it.


  if (init === null) {// no op
  } else if (_typeof(init) === 'object') {
    var method = init[Symbol.iterator];

    if (!isUndefined(method) && method !== null) {
      if (typeof method !== 'function') {
        throw new TypeError('Header pairs must be iterable');
      } // sequence<sequence<ByteString>>
      // Note: per spec we have to first exhaust the lists then process them


      var pairs = [];

      var _iterator2 = _createForOfIteratorHelper(init),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _pair = _step2.value;

          if (_typeof(_pair) !== 'object' || typeof _pair[Symbol.iterator] !== 'function') {
            throw new TypeError('Each header pair must be iterable');
          }

          pairs.push(Array.from(_pair));
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      for (var _i2 = 0, _pairs = pairs; _i2 < _pairs.length; _i2++) {
        var pair = _pairs[_i2];

        if (pair.length !== 2) {
          throw new TypeError('Each header pair must be a name/value tuple');
        }

        this.append(pair[0], pair[1]);
      }
    } else {
      // record<ByteString, ByteString>
      for (var _i3 = 0, _Object$keys = Object.keys(init); _i3 < _Object$keys.length; _i3++) {
        var key = _Object$keys[_i3];
        var _value = init[key];
        this.append(key, _value);
      }
    }
  } else {
    throw new TypeError('Provided initializer must be an object');
  }

  var ctx = mixin(this);
  return ctx;
}
/**
 * Mixin the prototype properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */


function mixin(obj) {
  for (var key in HttpHeaders.prototype) {
    if (Object.prototype.hasOwnProperty.call(HttpHeaders.prototype, key)) obj[key] = HttpHeaders.prototype[key];
  }

  return obj;
}
/**
 * Return combined header value given name
 *
 * @param   String  name  Header name
 * @return  Mixed
 */


HttpHeaders.prototype.get = function (name) {
  name = "".concat(name);
  validateName(name);
  var key = find(this[MAP], name);

  if (key === undefined) {
    return null;
  }

  return this[MAP][key].join(', ');
};
/**
 * Iterate over all headers
 *
 * @param   Function  callback  Executed for each item with parameters (value, name, thisArg)
 * @param   Boolean   thisArg   `this` context for callback function
 * @return  Void
 */


HttpHeaders.prototype.forEach = function (callback) {
  var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
  var pairs = getHeaders(this);
  var i = 0;

  while (i < pairs.length) {
    var _pairs$i = _slicedToArray(pairs[i], 2),
        name = _pairs$i[0],
        value = _pairs$i[1];

    callback.call(thisArg, value, name, this);
    pairs = getHeaders(this);
    i++;
  }
};
/**
 * Overwrite header values given name
 *
 * @param   String  name   Header name
 * @param   String  value  Header value
 * @return  Void
 */


HttpHeaders.prototype.set = function (name, value) {
  name = "".concat(name);
  value = "".concat(value);
  validateName(name);
  validateValue(value);
  var key = find(this[MAP], name);
  this[MAP][key !== undefined ? key : name] = [value];
};
/**
 * Append a value onto existing header
 *
 * @param   String  name   Header name
 * @param   String  value  Header value
 * @return  Void
 */


HttpHeaders.prototype.append = function (name, value) {
  name = "".concat(name); // name = name.toLowerCase();

  value = "".concat(value);
  validateName(name);
  validateValue(value);
  var key = find(this[MAP], name);

  if (key !== undefined) {
    this[MAP][key].push(value);
  } else {
    this[MAP][name] = [value];
  }
};
/**
 * Check for header name existence
 *
 * @param   String   name  Header name
 * @return  Boolean
 */


HttpHeaders.prototype.has = function (name) {
  name = "".concat(name);
  validateName(name);
  var value = find(this[MAP], name);
  var result = value !== undefined;
  return result;
};
/**
 * Delete all header values given name
 *
 * @param   String  name  Header name
 * @return  Void
 */


HttpHeaders.prototype.delete = function (name) {
  name = "".concat(name);
  validateName(name);
  var key = find(this[MAP], name);

  if (key !== undefined) {
    delete this[MAP][key];
  }
};
/**
 * Return raw headers (non-spec api)
 *
 * @return  Object
 */


HttpHeaders.prototype.raw = function () {
  return this[MAP];
};
/**
 * Get an iterator on keys.
 *
 * @return  Iterator
 */


HttpHeaders.prototype.keys = function () {
  return createHeadersIterator(this, 'key');
};
/**
 * Get an iterator on values.
 *
 * @return  Iterator
 */


HttpHeaders.prototype.values = function () {
  return createHeadersIterator(this, 'value');
};
/**
 * Get an iterator on entries.
 *
 * This is the default iterator of the HttpHeaders object.
 *
 * @return  Iterator
 */


HttpHeaders.prototype.entries = function () {
  return createHeadersIterator(this, 'key+value');
};
/**
 * Create a HttpHeaders object from an object of headers, ignoring those that do
 * not conform to HTTP grammar productions.
 *
 * @param   Object  obj  Object of headers
 * @return  HttpHeaders
 */


HttpHeaders.prototype.createHeadersLenient = function (obj) {
  var headers = new HttpHeaders();

  for (var _i4 = 0, _Object$keys2 = Object.keys(obj); _i4 < _Object$keys2.length; _i4++) {
    var name = _Object$keys2[_i4];

    if (invalidTokenRegex.test(name)) {
      continue;
    }

    if (Array.isArray(obj[name])) {
      var _iterator3 = _createForOfIteratorHelper(obj[name]),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var val = _step3.value;

          if (invalidHeaderCharRegex.test(val)) {
            continue;
          }

          if (headers[MAP][name] === undefined) {
            headers[MAP][name] = [val];
          } else {
            headers[MAP][name].push(val);
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
    } else if (!invalidHeaderCharRegex.test(obj[name])) {
      headers[MAP][name] = [obj[name]];
    }
  }

  return headers;
};

HttpHeaders.prototype.getAllHeaders = function () {
  var pairs = getHeaders(this);
  return pairs;
};