/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
'use strict';

require("core-js/modules/es.array.slice.js");

var _require = require('./_http_client'),
    ClientRequest = _require.ClientRequest;

var HTTPParser = require('./http-parser');

var methods = HTTPParser.methods;

var _require2 = require('./_http_incoming'),
    IncomingMessage = _require2.IncomingMessage;

var _require3 = require('./_http_outgoing'),
    validateHeaderName = _require3.validateHeaderName,
    validateHeaderValue = _require3.validateHeaderValue,
    OutgoingMessage = _require3.OutgoingMessage;

function request(url, options, cb) {
  return new ClientRequest(url, options, cb);
}

function get(url, options, cb) {
  var req = request(url, options, cb);
  req.end();
  return req;
}

module.exports = {
  METHODS: methods.slice().sort(),
  ClientRequest: ClientRequest,
  IncomingMessage: IncomingMessage,
  OutgoingMessage: OutgoingMessage,
  validateHeaderName: validateHeaderName,
  validateHeaderValue: validateHeaderValue,
  get: get,
  request: request
};