"use strict";

var _this = void 0;

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var MicroModal = require('micromodal');

var isNull = require('lodash.isnull');

var isUndefined = require('lodash.isundefined');
/**
 *	Inject HTML needed for the KeyPair Modal.
 *
 */


exports.inject = function () {
  var self = _this;
  htmlString = "\n        <div class=\"modal micromodal-slide\" id=\"ziti-keypair-modal\" aria-hidden=\"true\">\n            <div class=\"wrapper\">\n                <form class=\"form-signin\" name=\"zitikeypair\" id=\"ziti-keypair-form\">\n                    <header class=\"modal__header\">\n                        <h2 class=\"modal__title\" id=\"modal-1-title\">\n                            <img src=\"https://ziti-logo.s3.amazonaws.com/ziti-logo_avatar.png\" width=25 >\n                            <span>\n                                Zero-Trust KeyPair Generation\n                            </span>\n                        </h2>\n                    </header>\n                    <h2 class=\"form-signin-heading\">No KeyPair found in selected folder.<br/><br/>New KeyPair will be generated now.</h2>\n                    <span style=\"padding-top: 5px;\">&nbsp;</span>\n                    <div style=\"text-align: center; padding-top: 15px;\">\n                        <span id=\"ziti-keypair-error\" style=\"color: #e80853; font-weight: 800; font-size: 0.9em;\"></span> \n                    </div>    \n                    <div style=\"text-align: center; padding-top: 15px;\">\n                        <span id=\"ziti-keypair-progress\" style=\"color: #145fe9; font-weight: 800; font-size: 0.9em;\"></span> \n                    </div>\n                </form>\n            </div>\n            <footer class=\"modal__footer\"></footer>\n            <p class=\"ziti-footer\"  style=\"padding-top: 30px;\">\n                To access this application, you must be enrolled in the Ziti network.\n            </p>\n        </div>\n    ";

  if (isNull(document.body) || isUndefined(document.body)) {
    var body = document.createElement("body");
    document.documentElement.appendChild(body);
  }

  document.body.insertAdjacentHTML('afterbegin', htmlString);
};