"use strict";

var _this = void 0;

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var MicroModal = require('micromodal');

var isNull = require('lodash.isnull');

var isUndefined = require('lodash.isundefined'); // const dragDrop = require('drag-drop');

/**
 *	Inject HTML needed for the Identity Modal.
 *
 */


exports.inject = function (text) {
  var self = _this;
  htmlString = "\n  \n        <div class=\"modal micromodal-slide\" id=\"ziti-updb-modal-keypairDirectory\" aria-hidden=\"true\">\n            <div class=\"wrapper\">\n                <form class=\"form-signin\" name=\"zitikeypair\" id=\"ziti-keypair-form\">\n                    <header class=\"modal__header\">\n                        <h2 class=\"modal__title\" id=\"modal-1-title\">\n                            <img src=\"https://ziti-logo.s3.amazonaws.com/ziti-logo_avatar.png\" width=25 >\n                            <span>\n                                Zero-Trust KeyPair Selection\n                            </span>\n                        </h2>\n                    </header>\n\n                    <h2 class=\"form-signin-heading\">".concat(text, "</h2>\n                    <span style=\"padding-top: 5px;\">&nbsp;</span>\n                    <button id=\"ziti-keypairDirectory-button\" class=\"btn btn-lg btn-primary btn-block form-signin-button\" type=\"submit\">Select Folder</button>   \n                </form>\n            </div>\n\n            <div style=\"text-align: center;\">\n                <span id=\"ziti-identity-progress\" style=\"color: white; font-weight: 800\"></span> \n            </div>\n            <div style=\"text-align: center;\">\n                <span id=\"ziti-identity-error\" style=\"color: red; font-weight: 800\"></span> \n            </div>\n            \n            \n            <footer class=\"modal__footer\">\n            </footer>\n            \n            <p class=\"ziti-footer\" >\n                To access this application, you must be enrolled in the Ziti network.\n            </p>\n        </div>\n    \n    ");

  if (isNull(document.body) || isUndefined(document.body)) {
    var body = document.createElement("body");
    document.documentElement.appendChild(body);
  }

  document.body.insertAdjacentHTML('afterbegin', htmlString); // let div = document.createElement('div');
  // div.innerHTML = htmlString;
  // document.body.append(div);
};