"use strict";

require("regenerator-runtime/runtime.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.array-buffer.slice.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.typed-array.uint16-array.js");

require("core-js/modules/es.typed-array.copy-within.js");

require("core-js/modules/es.typed-array.every.js");

require("core-js/modules/es.typed-array.fill.js");

require("core-js/modules/es.typed-array.filter.js");

require("core-js/modules/es.typed-array.find.js");

require("core-js/modules/es.typed-array.find-index.js");

require("core-js/modules/es.typed-array.for-each.js");

require("core-js/modules/es.typed-array.includes.js");

require("core-js/modules/es.typed-array.index-of.js");

require("core-js/modules/es.typed-array.iterator.js");

require("core-js/modules/es.typed-array.join.js");

require("core-js/modules/es.typed-array.last-index-of.js");

require("core-js/modules/es.typed-array.map.js");

require("core-js/modules/es.typed-array.reduce.js");

require("core-js/modules/es.typed-array.reduce-right.js");

require("core-js/modules/es.typed-array.reverse.js");

require("core-js/modules/es.typed-array.set.js");

require("core-js/modules/es.typed-array.slice.js");

require("core-js/modules/es.typed-array.some.js");

require("core-js/modules/es.typed-array.sort.js");

require("core-js/modules/es.typed-array.subarray.js");

require("core-js/modules/es.typed-array.to-locale-string.js");

require("core-js/modules/es.typed-array.to-string.js");

require("core-js/modules/es.array-buffer.constructor.js");

require("core-js/modules/es.promise.js");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var isUndefined = require('lodash.isundefined');

var isNull = require('lodash.isnull');

var ZitiPKI = require('../pki/pki');

var ls = require('../utils/localstorage');

var zitiConstants = require('../constants');
/**
 *	Inject JS select change-handler for the Identity Modal.
 *
 */


exports.injectButtonHandler = function (updb, source, cb) {
  var keypairDirectoryButton = document.getElementById("ziti-keypairDirectory-button");

  keypairDirectoryButton.onclick = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(e) {
      var ab2str, str2ab, directoryHandle, _publicKeyfileHandle, _privateKeyfileHandle, publicKeyfile, publicKeyfileContents, privateKeyfile, privateKeyfileContents, publicKey, privateKey, perms, publicKeyfileWritable, privateKeyfileWritable;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              str2ab = function _str2ab(str) {
                var buf = new ArrayBuffer(str.length * 2); // 2 bytes for each char

                var bufView = new Uint16Array(buf);

                for (var i = 0, strLen = str.length; i < strLen; i++) {
                  bufView[i] = str.charCodeAt(i);
                }

                return buf;
              };

              ab2str = function _ab2str(buf) {
                return String.fromCharCode.apply(null, new Uint16Array(buf));
              };

              e.preventDefault();
              _context.next = 5;
              return window.showDirectoryPicker({});

            case 5:
              directoryHandle = _context.sent;

              ziti._ctx.logger.debug('got directoryHandle: ', directoryHandle);

              if (!(source == zitiConstants.get().ZITI_IDENTITY_KEYPAIR_OBTAIN_FROM_FS)) {
                _context.next = 44;
                break;
              }

              _context.next = 10;
              return directoryHandle.getFileHandle(zitiConstants.get().ZITI_IDENTITY_PUBLIC_KEY_FILENAME, {
                create: false
              }).catch(function (err) {
                ziti._ctx.logger.warn(err);
              });

            case 10:
              _publicKeyfileHandle = _context.sent;

              ziti._ctx.logger.debug('publicKeyfileHandle: ', _publicKeyfileHandle);

              _context.next = 14;
              return directoryHandle.getFileHandle(zitiConstants.get().ZITI_IDENTITY_PRIVATE_KEY_FILENAME, {
                create: false
              }).catch(function (err) {
                ziti._ctx.logger.warn(err);
              });

            case 14:
              _privateKeyfileHandle = _context.sent;

              ziti._ctx.logger.debug('privateKeyfileHandle: ', _privateKeyfileHandle); // If public key NOT present in chosen directory


              if (!isUndefined(_publicKeyfileHandle)) {
                _context.next = 19;
                break;
              }

              cb(zitiConstants.get().ZITI_IDENTITY_PUBLIC_KEY_FILE_NOT_FOUND);
              return _context.abrupt("return");

            case 19:
              if (!isUndefined(_privateKeyfileHandle)) {
                _context.next = 22;
                break;
              }

              cb(zitiConstants.get().ZITI_IDENTITY_PRIVATE_KEY_FILE_NOT_FOUND);
              return _context.abrupt("return");

            case 22:
              _context.next = 24;
              return _publicKeyfileHandle.getFile();

            case 24:
              publicKeyfile = _context.sent;
              _context.next = 27;
              return publicKeyfile.arrayBuffer();

            case 27:
              publicKeyfileContents = _context.sent;
              publicKeyfileContents = ab2str(publicKeyfileContents);
              _context.next = 31;
              return ls.setWithExpiry(zitiConstants.get().ZITI_IDENTITY_PUBLIC_KEY, publicKeyfileContents, new Date(8640000000000000));

            case 31:
              _context.next = 33;
              return _privateKeyfileHandle.getFile();

            case 33:
              privateKeyfile = _context.sent;
              _context.next = 36;
              return privateKeyfile.arrayBuffer();

            case 36:
              privateKeyfileContents = _context.sent;
              privateKeyfileContents = ab2str(privateKeyfileContents);
              _context.next = 40;
              return ls.setWithExpiry(zitiConstants.get().ZITI_IDENTITY_PRIVATE_KEY, privateKeyfileContents, new Date(8640000000000000));

            case 40:
              cb(zitiConstants.get().ZITI_IDENTITY_KEYPAIR_FOUND);
              return _context.abrupt("return");

            case 44:
              if (!(source == zitiConstants.get().ZITI_IDENTITY_KEYPAIR_OBTAIN_FROM_IDB)) {
                _context.next = 101;
                break;
              }

              ziti._ctx.logger.debug('Must pull keypair from IndexedDb'); // Obtain the keypair from IndexedDb


              _context.next = 48;
              return ls.get(zitiConstants.get().ZITI_IDENTITY_PUBLIC_KEY);

            case 48:
              publicKey = _context.sent;
              _context.next = 51;
              return ls.get(zitiConstants.get().ZITI_IDENTITY_PRIVATE_KEY);

            case 51:
              privateKey = _context.sent;

              ziti._ctx.logger.debug('publicKey: ', publicKey);

              ziti._ctx.logger.debug('privateKey: ', privateKey);

              if (!(isNull(publicKey) || isUndefined(publicKey) || isNull(privateKey) || isUndefined(privateKey))) {
                _context.next = 56;
                break;
              }

              throw new Error('WTF');

            case 56:
              _context.next = 58;
              return directoryHandle.getFileHandle(zitiConstants.get().ZITI_IDENTITY_PUBLIC_KEY_FILENAME, {
                create: true
              }).catch(function (err) {
                ziti._ctx.logger.info(err);
              });

            case 58:
              publicKeyfileHandle = _context.sent;

              ziti._ctx.logger.debug('publicKeyfileHandle: ', publicKeyfileHandle); // Determine if the private key file is in the selected directory already


              _context.next = 62;
              return directoryHandle.getFileHandle(zitiConstants.get().ZITI_IDENTITY_PRIVATE_KEY_FILENAME, {
                create: true
              }).catch(function (err) {
                ziti._ctx.logger.info(err);
              });

            case 62:
              privateKeyfileHandle = _context.sent;

              ziti._ctx.logger.debug('privateKeyfileHandle: ', privateKeyfileHandle); // Prepare to write the keypair files to disk


              _context.next = 66;
              return publicKeyfileHandle.queryPermission();

            case 66:
              perms = _context.sent;

              ziti._ctx.logger.debug('publicKeyfileHandle perms: ', perms);

              _context.next = 70;
              return publicKeyfileHandle.createWritable({
                keepExistingData: false
              }).catch(function (err) {
                ziti._ctx.logger.info(err);
              });

            case 70:
              publicKeyfileWritable = _context.sent;

              ziti._ctx.logger.debug('publicKeyfileWritable: ', publicKeyfileWritable);

              _context.next = 74;
              return privateKeyfileHandle.queryPermission();

            case 74:
              perms = _context.sent;

              ziti._ctx.logger.debug('privateKeyfileHandle perms: ', perms);

              _context.next = 78;
              return privateKeyfileHandle.createWritable({
                keepExistingData: false
              }).catch(function (err) {
                ziti._ctx.logger.info(err);
              });

            case 78:
              privateKeyfileWritable = _context.sent;

              ziti._ctx.logger.debug('privateKeyfileWritable: ', privateKeyfileWritable); // If we don't have writability


              if (!(isUndefined(publicKeyfileWritable) && isUndefined(privateKeyfileWritable))) {
                _context.next = 83;
                break;
              }

              ziti._ctx.logger.info('Failed to get writable filehandles');

              throw new Error('WTF');

            case 83:
              ziti._ctx.logger.info('doing publicKeyfileWritable.write');

              _context.next = 86;
              return publicKeyfileWritable.write(str2ab(publicKey));

            case 86:
              ziti._ctx.logger.info('completed publicKeyfileWritable.write');

              _context.next = 89;
              return publicKeyfileWritable.close();

            case 89:
              ziti._ctx.logger.info('completed publicKeyfileWritable.close');

              ziti._ctx.logger.info('doing privateKeyfileWritable.write');

              _context.next = 93;
              return privateKeyfileWritable.write(str2ab(privateKey));

            case 93:
              ziti._ctx.logger.info('completed privateKeyfileWritable.write');

              _context.next = 96;
              return privateKeyfileWritable.close();

            case 96:
              ziti._ctx.logger.info('completed privateKeyfileWritable.close');

              cb(zitiConstants.get().ZITI_IDENTITY_KEYPAIR_FOUND);
              return _context.abrupt("return");

            case 101:
              throw new Error('WTF');

            case 102:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();
};