"use strict";

require("regenerator-runtime/runtime.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var isNull = require('lodash.isnull');

var localforage = require('localforage');

localforage.config({
  driver: localforage.INDEXEDDB,
  name: 'ziti_sdk_js',
  version: 1.0,
  storeName: 'ziti_sdk_js_db',
  // Should be alphanumeric, with underscores.
  description: 'Ziti JS SDK database'
});
/**
 *	Save specified value under specified key
 *	as well as the time when it's supposed to lazily expire
 *
 * @param {Object} key
 * @param {Object} value
 * @param {Object} ttl
 */

exports.setWithExpiry = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(key, value, ttl) {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt("return", new Promise( /*#__PURE__*/function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(resolve, reject) {
                var item;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        if (isNull(ttl)) {
                          ttl = new Date(8640000000000000);
                        }

                        if (Object.prototype.toString.call(ttl) === '[object Date]') {
                          ttl = ttl.getTime();
                        }

                        item = {
                          value: value,
                          expiry: ttl,
                          expiryDate: new Date(ttl)
                        };
                        _context.next = 5;
                        return localforage.setItem(key, item);

                      case 5:
                        resolve();

                      case 6:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x4, _x5) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 1:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();
/**
 *	Return value for specified key
 *	or null if not found, or expired.
 *
 * @param {Object} key
 * @return {Object} value
 */


exports.getWithExpiry = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(key) {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt("return", new Promise( /*#__PURE__*/function () {
              var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(resolve, reject) {
                var item, now;
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.next = 2;
                        return localforage.getItem(key);

                      case 2:
                        item = _context3.sent;

                        if (!isNull(item)) {
                          _context3.next = 7;
                          break;
                        }

                        resolve(null);
                        _context3.next = 15;
                        break;

                      case 7:
                        now = new Date(); // compare the expiry time of the item with the current time

                        if (!(!isNull(item.expiry) && now.getTime() > item.expiry)) {
                          _context3.next = 14;
                          break;
                        }

                        _context3.next = 11;
                        return localforage.removeItem(key);

                      case 11:
                        resolve(null);
                        _context3.next = 15;
                        break;

                      case 14:
                        resolve(item.value);

                      case 15:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function (_x7, _x8) {
                return _ref4.apply(this, arguments);
              };
            }()));

          case 1:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function (_x6) {
    return _ref3.apply(this, arguments);
  };
}();
/**
 *	Return expiry value for specified key
 *	or null if not found, or expired.
 *
 * @param {Object} key
 * @return {Object} expiry value
 */


exports.getExpiry = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(key) {
    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            return _context6.abrupt("return", new Promise( /*#__PURE__*/function () {
              var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(resolve, reject) {
                var item, now;
                return regeneratorRuntime.wrap(function _callee5$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                        _context5.next = 2;
                        return localforage.getItem(key);

                      case 2:
                        item = _context5.sent;

                        if (!isNull(item)) {
                          _context5.next = 7;
                          break;
                        }

                        resolve(null);
                        _context5.next = 15;
                        break;

                      case 7:
                        now = new Date(); // compare the expiry time of the item with the current time

                        if (!(!isNull(item.expiry) && now.getTime() > item.expiry)) {
                          _context5.next = 14;
                          break;
                        }

                        _context5.next = 11;
                        return localforage.removeItem(key);

                      case 11:
                        resolve(null);
                        _context5.next = 15;
                        break;

                      case 14:
                        resolve(item.expiry);

                      case 15:
                      case "end":
                        return _context5.stop();
                    }
                  }
                }, _callee5);
              }));

              return function (_x10, _x11) {
                return _ref6.apply(this, arguments);
              };
            }()));

          case 1:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));

  return function (_x9) {
    return _ref5.apply(this, arguments);
  };
}();
/**
 *	Return value for specified key
 *	or null if not found.
 *
 * @param {Object} key
 * @return {Object} value
 */


exports.get = /*#__PURE__*/function () {
  var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(key) {
    return regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            return _context8.abrupt("return", new Promise( /*#__PURE__*/function () {
              var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(resolve, reject) {
                var item;
                return regeneratorRuntime.wrap(function _callee7$(_context7) {
                  while (1) {
                    switch (_context7.prev = _context7.next) {
                      case 0:
                        _context7.next = 2;
                        return localforage.getItem(key);

                      case 2:
                        item = _context7.sent;

                        // if the item doesn't exist, return null
                        if (isNull(item)) {
                          resolve(null);
                        } else {
                          resolve(item.value);
                        }

                      case 4:
                      case "end":
                        return _context7.stop();
                    }
                  }
                }, _callee7);
              }));

              return function (_x13, _x14) {
                return _ref8.apply(this, arguments);
              };
            }()));

          case 1:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8);
  }));

  return function (_x12) {
    return _ref7.apply(this, arguments);
  };
}();
/**
 *	Remove value for specified key
 * 
 * @param {*} key 
 */


exports.removeItem = /*#__PURE__*/function () {
  var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(key) {
    return regeneratorRuntime.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            _context9.next = 2;
            return localforage.removeItem(key);

          case 2:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9);
  }));

  return function (_x15) {
    return _ref9.apply(this, arguments);
  };
}();