"use strict";

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.array.from.js");

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.object.assign.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.slice.js");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var ZitiReporter = /*#__PURE__*/function () {
  function ZitiReporter(options) {
    _classCallCheck(this, ZitiReporter);

    this.options = Object.assign({}, options);
    this.defaultColor = '#7f8c8d'; // Gray

    this.levelColorMap = {
      0: '#f60404',
      // Red      FATAL | ERROR
      1: '#ff5c00',
      // Orange   WARN
      2: '#ffeb3b',
      // Yellow   LOG
      3: '#4caf50',
      // Green    INFO
      4: '#008efe',
      // Blue     DEBUG
      5: '#04e2fe' // Cyan     TRACE

    };
    this.typeColorMap = {
      success: '#ee0450' // 
      // success: '#2ecc71'  // Green

    };
  }

  _createClass(ZitiReporter, [{
    key: "log",
    value: function log(logObj) {
      var consoleLogFn = logObj.level < 1 // eslint-disable-next-line no-console
      ? console.__error || console.error // eslint-disable-next-line no-console
      : logObj.level === 1 && console.warn ? console.__warn || console.warn : console.__log || console.log; // Type

      var type = logObj.type !== 'log' ? logObj.type : ''; // Tag

      var tag = logObj.tag ? logObj.tag : ''; // Styles

      var color = this.typeColorMap[logObj.type] || this.levelColorMap[logObj.level] || this.defaultColor;
      var successStyle = "\n        border-radius: 1.5em;\n        color: white;\n        font-weight: bold;\n        padding: 10px 1.5em;\n        background-image: linear-gradient(to bottom right, #0e61ed , #ee044f);\n      ";
      var normalStyle = "\n        background: ".concat(color, ";\n        border-radius: 1.5em;\n        color: white;\n        font-weight: bold;\n        padding: 2px 0.5em;\n      ");
      var style = logObj.type === 'success' ? successStyle : normalStyle;
      var badge = logObj.type === 'success' ? "%cZiti" : "%cZiti-".concat([tag, type].filter(Boolean).join(':')); // Log to the console

      if (typeof logObj.args[0] === 'string') {
        consoleLogFn.apply(void 0, ["".concat(badge, "%c ").concat(logObj.args[0]), style, // Empty string as style resets to default console style
        ''].concat(_toConsumableArray(logObj.args.slice(1))));
      } else {
        consoleLogFn.apply(void 0, [badge, style].concat(_toConsumableArray(logObj.args)));
      }
    }
  }]);

  return ZitiReporter;
}();
/**
 * Expose `ZitiReporter`.
 */


module.exports = ZitiReporter;