"use strict";

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/**
 *	Inject CSS needed for the Identity Modal.
 *
 */
exports.inject = function () {
  styleString = "\n\n\t// body {\n\t// \tbackground: #eee !important;\n\t//   }\n\t  \n\t* {\n\t\t-webkit-box-sizing: border-box;\n\t\t-moz-box-sizing: border-box;\n\t\tbox-sizing: border-box;\n\t}\n\n\t.h1, .h2, .h3, .h4, .h5, .h6, h1, h2, h3, h4, h5, h6 {\n\t\tfont-family: inherit;\n\t\tfont-weight: 500;\n\t\tline-height: 1.1;\n\t\tcolor: inherit;\n\t}\n\n\t  .wrapper {\n\t\tmargin-top: 80px;\n\t\tmargin-bottom: 80px;\n\t\tposition: relative; \n\t\tz-index: 999;\n\t  }\n\t  \n\t  .form-signin {\n\t\tborder-radius: 10px;\n\t\tmax-width: 380px;\n\t\tpadding: 15px 35px 45px;\n\t\tmargin: 0 auto;\n\t\tbackground-color: #fff;\n\t\tborder: 1px solid rgba(0, 0, 0, 0.1);\n\t\tbox-sizing: border-box;\n\t  }\n\t  .form-signin .form-signin-heading,\n\t  .form-signin .checkbox {\n\t\tmargin-bottom: 30px;\n\t\tfont-size: 18px;\n\t\tcolor: black;\n\t\tfont-family: sans-serif;\n\t  }\n\t  .form-signin .checkbox {\n\t\tfont-weight: normal;\n\t  }\n\t  .form-signin .form-control {\n\t\tposition: relative;\n\t\tfont-size: 16px;\n\t\theight: auto;\n\t\tpadding: 10px;\n\t\t-webkit-box-sizing: border-box;\n\t\t-moz-box-sizing: border-box;\n\t\tbox-sizing: border-box;\n\t  }\n\t  .form-signin .form-control:focus {\n\t\tz-index: 2;\n\t  }\n\t  .form-signin input[type=\"text\"] {\n\t\tmargin-bottom: -1px;\n\t\tborder-bottom-left-radius: 0;\n\t\tborder-bottom-right-radius: 0;\n\t  }\n\t  .form-signin input[type=\"password\"] {\n\t\tmargin-bottom: 20px;\n\t\tborder-top-left-radius: 0;\n\t\tborder-top-right-radius: 0;\n\t  }\n\n\t  ::placeholder {\n\t\tcolor: #9e9e9e;\n\t  }\n\t  \n\t  .form-signin-button {\n\t\tbackground-image: linear-gradient(to bottom right, #082481 , #e00043);\n\t  }\n  \n  \t.modal {\n\t  \tfont-family: -apple-system,BlinkMacSystemFont,avenir next,avenir,helvetica neue,helvetica,ubuntu,roboto,noto,segoe ui,arial,sans-serif;\n\t  \tbackground-image: linear-gradient(to bottom right, #082481 , #e00043);\n\t\tposition: fixed;\n\t\ttop: 0;\n\t\tright: 0;\n\t\tbottom: 0;\n\t\tleft: 0;\n\t\tz-index: 1050;\n\t\tdisplay: none;\n\t\toverflow: hidden;\n\t\t-webkit-overflow-scrolling: touch;\n\t\toutline: 0;\n\t}\n\n\t\n\t.modal__overlay {\n\t  position: fixed;\n\t  top: 0;\n\t  left: 0;\n\t  right: 0;\n\t  bottom: 0;\n\t  background: rgba(0,0,0,0.6);\n\t  display: flex;\n\t  justify-content: center;\n\t  align-items: center;\n\t}\n\t\n\t.modal__container {\n\t  background-color: #fff;\n\t  padding: 30px;\n\t  /* max-width: 500px; */\n\t  max-height: 100vh;\n\t  border-radius: 4px;\n\t  overflow-y: auto;\n\t  box-sizing: border-box;\n\t}\n\t\n\t.modal__header {\n\t  display: flex;\n\t  justify-content: space-between;\n\t  align-items: center;\n\t  border-bottom: 1px solid #00449e;\n\t  padding-bottom: 8px;\n\t  position: relative;\n\t  background: white\n\t}\n\t\n\t.modal__title {\n\t  margin-top: 0;\n\t  margin-bottom: 0;\n\t  font-weight: 600;\n\t  font-size: 1.0rem;\n\t  line-height: 1.0;\n\t  color: #000000;\n\t  box-sizing: border-box;\n\t  font-family: sans-serif;\n\t}\n\n\t.modal__title span {\n\t\tdisplay: block;\n\t\tposition: absolute;\n\t\theight: 16px;\n\t\ttop: 50%;\n\t\tmargin-top: -14px;\n\t\tmargin-left: 32px;\n\t\tfont-size: 18px;\n\t}\n\t\n\t\n\t.modal__close {\n\t  background: transparent;\n\t  border: 0;\n\t}\n\t\n\t.modal__header .modal__close:before { content: \"\\2715\"; }\n\t\n\t.modal__content {\n\t  margin-top: 2rem;\n\t  margin-bottom: 2rem;\n\t  line-height: 1.5;\n\t  color: rgba(0,0,0,.8);\n\t}\n  \n\t.modal__content p {\n\t  text-align: center;\n\t}\n  \n\tlabel.modal__upload {\n\t  width: 100%;\n\t}\n  \n\t.modal__btn {\n\t  font-size: .875rem;\n\t  padding-left: 1rem;\n\t  padding-right: 1rem;\n\t  padding-top: .5rem;\n\t  padding-bottom: .5rem;\n\t  background-color: #e6e6e6;\n\t  color: rgba(0,0,0,.8);\n\t  border-radius: .25rem;\n\t  border-style: none;\n\t  border-width: 0;\n\t  cursor: pointer;\n\t  -webkit-appearance: button;\n\t  text-transform: none;\n\t  overflow: visible;\n\t  line-height: 1.15;\n\t  margin: 0;\n\t  will-change: transform;\n\t  -moz-osx-font-smoothing: grayscale;\n\t  -webkit-backface-visibility: hidden;\n\t  backface-visibility: hidden;\n\t  -webkit-transform: translateZ(0);\n\t  transform: translateZ(0);\n\t  transition: -webkit-transform .25s ease-out;\n\t  transition: transform .25s ease-out;\n\t  transition: transform .25s ease-out,-webkit-transform .25s ease-out;\n\t}\n\t\n\t.modal__btn:focus, .modal__btn:hover {\n\t  -webkit-transform: scale(1.05);\n\t  transform: scale(1.05);\n\t}\n\t\n\t.modal__btn-primary {\n\t  background-color: #00449e;\n\t  color: #fff;\n\t}\n\t\n\t\n\t\n\t/**************************\t  Demo Animation Style\n\t**************************/\n\t@keyframes mmfadeIn {\n\t\tfrom { opacity: 0; }\n\t\t  to { opacity: 1; }\n\t}\n\t\n\t@keyframes mmfadeOut {\n\t\tfrom { opacity: 1; }\n\t\t  to { opacity: 0; }\n\t}\n\t\n\t@keyframes mmslideIn {\n\t  from { transform: translateY(15%); }\n\t\tto { transform: translateY(0); }\n\t}\n\t\n\t@keyframes mmslideOut {\n\t\tfrom { transform: translateY(0); }\n\t\tto { transform: translateY(-10%); }\n\t}\n\t\n\t.micromodal-slide {\n\t  display: none;\n\t}\n\t\n\t.micromodal-slide.is-open {\n\t  display: block;\n\t}\n\t\n\t.micromodal-slide[aria-hidden=\"false\"] .modal__overlay {\n\t  animation: mmfadeIn .3s cubic-bezier(0.0, 0.0, 0.2, 1);\n\t}\n\t\n\t.micromodal-slide[aria-hidden=\"false\"] .modal__container {\n\t  animation: mmslideIn .3s cubic-bezier(0, 0, .2, 1);\n\t}\n\t\n\t.micromodal-slide[aria-hidden=\"true\"] .modal__overlay {\n\t  animation: mmfadeOut .3s cubic-bezier(0.0, 0.0, 0.2, 1);\n\t}\n\t\n\t.micromodal-slide[aria-hidden=\"true\"] .modal__container {\n\t  animation: mmslideOut .3s cubic-bezier(0, 0, .2, 1);\n\t}\n\t\n\t.micromodal-slide .modal__container,\n\t.micromodal-slide .modal__overlay {\n\t  will-change: transform;\n\t}  \n  \n\t.ziti-footer {\n\t  font-family: 'Roboto', 'Noto', sans-serif;\n\t  font-weight: 400;\n\t  -webkit-font-smoothing: antialiased;\n\t  letter-spacing: 0.011em;\n\t  font-size: 12px;\n\t  line-height: 16px;\n\t  color: white;\n\t  text-align: center;\n\t}\n  \n\t.btn-block {\n\t\tdisplay: block;\n\t\twidth: 100%;\n\t}\n\t.btn-group-lg>.btn, .btn-lg {\n\t\tpadding: 10px 16px;\n\t\tfont-size: 18px;\n\t\tline-height: 1.3333333;\n\t\tborder-radius: 6px;\n\t}\n\t.btn-primary {\n\t\tcolor: #fff;\n\t\tbackground-color: #337ab7;\n\t\tborder-color: #2e6da4;\n\t}\n\t.btn {\n\t\tdisplay: inline-block;\n\t\tpadding: 6px 12px;\n\t\tmargin-bottom: 0;\n\t\tfont-size: 14px;\n\t\tfont-weight: 400;\n\t\tline-height: 1.42857143;\n\t\ttext-align: center;\n\t\twhite-space: nowrap;\n\t\tvertical-align: middle;\n\t\t-ms-touch-action: manipulation;\n\t\ttouch-action: manipulation;\n\t\tcursor: pointer;\n\t\t-webkit-user-select: none;\n\t\t-moz-user-select: none;\n\t\t-ms-user-select: none;\n\t\tuser-select: none;\n\t\t// background-image: none;\n\t\tborder: 1px solid transparent;\n\t\tborder-radius: 4px;\n\t\tfont-family: sans-serif;\n\t}\n\t\n\tbutton, input, select, textarea {\n\t\tfont-family: inherit;\n\t\tfont-size: inherit;\n\t\tline-height: inherit;\n\t}\n\tbutton, html input[type=button], input[type=reset], input[type=submit] {\n\t\t-webkit-appearance: button;\n\t\tcursor: pointer;\n\t}\n\tbutton, select {\n\t\ttext-transform: none;\n\t}\n\tbutton {\n\t\toverflow: visible;\n\t}\n\tbutton, input, optgroup, select, textarea {\n\t\tmargin: 0;\n\t\tfont: inherit;\n\t\tcolor: inherit;\n\t}\n\tbutton, input, select, textarea {\n\t\tfont-family: inherit;\n\t\tfont-size: inherit;\n\t\tline-height: inherit;\n\t}\n\tbutton, html input[type=button], input[type=reset], input[type=submit] {\n\t\t-webkit-appearance: button;\n\t\tcursor: pointer;\n\t}\n\tbutton, select {\n\t\ttext-transform: none;\n\t}\n\tbutton {\n\t\toverflow: visible;\n\t}\n\tbutton, input, optgroup, select, textarea {\n\t\tmargin: 0;\n\t\tfont: inherit;\n\t\tcolor: inherit;\n\t}\n\t* {\n\t\t-webkit-box-sizing: border-box;\n\t\t-moz-box-sizing: border-box;\n\t\tbox-sizing: border-box;\n\t}\n\t* {\n\t\t-webkit-box-sizing: border-box;\n\t\t-moz-box-sizing: border-box;\n\t\tbox-sizing: border-box;\n\t}\n\n\t.form-control {\n\t\tdisplay: block;\n\t\twidth: 100%;\n\t\theight: 34px;\n\t\tpadding: 6px 12px;\n\t\tfont-size: 14px;\n\t\tline-height: 1.42857143;\n\t\tcolor: #555;\n\t\tbackground-color: #fff;\n\t\tbackground-image: none;\n\t\tborder: 1px solid #ccc;\n\t\tborder-radius: 4px;\n\t\t-webkit-box-shadow: inset 0 1px 1px rgb(0 0 0 / 8%);\n\t\tbox-shadow: inset 0 1px 1px rgb(0 0 0 / 8%);\n\t\t-webkit-transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;\n\t\t-o-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;\n\t\ttransition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;\n\t\tfont-family: sans-serif;\n\t}\t\n\t";
  var style = document.createElement('style');
  style.textContent = styleString;
  document.head.append(style); // document.head.insertAdjacentHTML('afterbegin', `
  //   <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/css/bootstrap.min.css" rel="stylesheet"/>
  // `);
};